package com.example.survey.controller;

import com.example.survey.entity.inner.AdministrativeArea;
import com.example.survey.service.RespondentService;
import com.example.survey.dto.RespondentDto;
import com.example.survey.vo.CreateRespondentVo;
import com.example.survey.vo.ResultVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @author Pope
 */
@RestController
@RequestMapping("/respondent")
public class RespondentController {

    @Autowired
    private RespondentService respondentService;

    @PostMapping("/respondent")
    public ResultVo addRespondent(@RequestBody CreateRespondentVo createRespondentVo) {
        ResultVo resultVo = new ResultVo();

        boolean result = respondentService.addRespondent(createRespondentVo);
        if (result) {
            resultVo.setCode(ResultVo.SUCCESS);
            resultVo.setMsg("创建成功");
        } else {
            resultVo.setCode(ResultVo.FAILED);
            resultVo.setMsg("创建失败");
        }
        resultVo.setData(result);

        return resultVo;
    }

    @GetMapping("/respondent")
    public ResultVo countRespondent(@RequestParam(value = "userPhone") String userPhone,
                                    @RequestParam(value = "state", required = false) String state,
                                    @RequestParam(value = "province", required = false) String province,
                                    @RequestParam(value = "city", required = false) String city,
                                    @RequestParam(value = "county", required = false) String county,
                                    @RequestParam(value = "currentPage") int currentPage,
                                    @RequestParam(value = "pageSize", defaultValue = "30") int pageSize) {
        ResultVo resultVo = new ResultVo();
        Map<String, Object> resultMap = new HashMap<>(16, 0.75F);
        AdministrativeArea administrativeArea = new AdministrativeArea(province, city, county);
        List<RespondentDto> voList = respondentService.listRespondentLimit(userPhone, state, administrativeArea, currentPage, pageSize);
        resultMap.put("totalCount", respondentService.countRespondent(userPhone, state, administrativeArea));
        resultMap.put("currentPage", currentPage);
        resultMap.put("pageSize", pageSize);
        resultMap.put("data", voList);

        resultVo.setCode(ResultVo.SUCCESS);
        resultVo.setMsg("查询成功");
        resultVo.setData(resultMap);

        return resultVo;
    }

}
