package com.example.survey.controller.advice;

import com.example.survey.exception.*;
import com.example.survey.vo.ResultVo;
import org.springframework.web.bind.annotation.ControllerAdvice;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.RestControllerAdvice;

/**
 * @author Pope
 */
@RestControllerAdvice
public class GlobalExceptionHandler {

    @ExceptionHandler(UserException.class)
    public ResultVo handleUserException(UserException e) {
        ResultVo resultVo = new ResultVo();

        resultVo.setCode(ResultVo.FAILED);
        resultVo.setMsg(e.getMessage());

        return resultVo;
    }


    @ExceptionHandler(RecordException.class)
    public ResultVo handleRecordException(RecordException e) {
        ResultVo resultVo = new ResultVo();

        resultVo.setCode(ResultVo.FAILED);
        resultVo.setMsg(e.getMessage());

        return resultVo;
    }

    @ExceptionHandler(RespondentException.class)
    public ResultVo handleRespondentException(RespondentException e) {
        ResultVo resultVo = new ResultVo();

        resultVo.setCode(ResultVo.FAILED);
        resultVo.setMsg(e.getMessage());

        return resultVo;
    }

    @ExceptionHandler(RoleException.class)
    public ResultVo handleRoleException(RoleException e) {
        ResultVo resultVo = new ResultVo();

        resultVo.setCode(ResultVo.FAILED);
        resultVo.setMsg(e.getMessage());

        return resultVo;
    }

    @ExceptionHandler(DepartmentException.class)
    public ResultVo handleDepartmentException(DepartmentException e) {
        ResultVo resultVo = new ResultVo();

        resultVo.setCode(ResultVo.FAILED);
        resultVo.setMsg(e.getMessage());

        return resultVo;
    }

    @ExceptionHandler(AuthException.class)
    public ResultVo handleAuthException(AuthException e) {
        ResultVo resultVo = new ResultVo();

        resultVo.setCode(ResultVo.FAILED);
        resultVo.setMsg(e.getMessage());

        return resultVo;
    }

}
