package com.example.survey.entity.inner;

import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * @author Pope\
 * 入境经历
 */
public class EntryExperience {
    /**
     * 入境前居住或旅行的国家或地区
     */
    private String areaOfResidence;

    /**
     * 入境前途径的国家或地区
     */
    private String areaOfAccess;

    /**
     * 国籍
     */
    private String nationality;

    /**
     * 护照号码
     */
    private String passportNumber;

    /**
     * 入境口岸
     */
    private EntryPort entryPort;

    /**
     * 入境日期
     * 年月日
     */
    @JsonFormat(pattern = "yyyy-MM-dd")
    private Date entryDate;

    /**
     * 入境交通方式
     * 航班号、车次、船号等
     */
    private String transportation;


    public EntryExperience() {
    }

    public EntryExperience(String areaOfResidence, String areaOfAccess, String nationality, String passportNumber, EntryPort entryPort, Date entryDate, String transportation) {
        this.areaOfResidence = areaOfResidence;
        this.areaOfAccess = areaOfAccess;
        this.nationality = nationality;
        this.passportNumber = passportNumber;
        this.entryPort = entryPort;
        this.entryDate = entryDate;
        this.transportation = transportation;
    }

    public String getAreaOfResidence() {
        return areaOfResidence;
    }

    public void setAreaOfResidence(String areaOfResidence) {
        this.areaOfResidence = areaOfResidence;
    }

    public String getAreaOfAccess() {
        return areaOfAccess;
    }

    public void setAreaOfAccess(String areaOfAccess) {
        this.areaOfAccess = areaOfAccess;
    }

    public String getNationality() {
        return nationality;
    }

    public void setNationality(String nationality) {
        this.nationality = nationality;
    }

    public String getPassportNumber() {
        return passportNumber;
    }

    public void setPassportNumber(String passportNumber) {
        this.passportNumber = passportNumber;
    }

    public EntryPort getEntryPort() {
        return entryPort;
    }

    public void setEntryPort(EntryPort entryPort) {
        this.entryPort = entryPort;
    }

    public Date getEntryDate() {
        return entryDate;
    }

    public void setEntryDate(Date entryDate) {
        this.entryDate = entryDate;
    }

    public String getTransportation() {
        return transportation;
    }

    public void setTransportation(String transportation) {
        this.transportation = transportation;
    }
}
